package classroomserver;

import java.io.*;
import java.net.*;
import java.util.logging.Level;
import java.util.logging.Logger;

public class ServerTCP {

    ServerDB serverdb=new ServerDB();

    int idLock;
    String classRoom;
    String rutFromLock;
    boolean status;
    int Port=6969;
    DataInputStream inFromClient;
    DataOutputStream outToClient;
    Socket connectionSocket;
    ServerSocket welcomeSocket;


    private void InitSqlConnection(){

        serverdb.SqlConnection("user", "password");

    }


    public void RunServer() throws Exception{

        welcomeSocket = new ServerSocket(Port);

        InitSqlConnection();


        while(true) {

            connectionSocket = welcomeSocket.accept();

            inFromClient = new DataInputStream(connectionSocket.getInputStream());
            
            idLock=inFromClient.readInt();

            BufferedReader inFromClientText = new BufferedReader(new InputStreamReader(connectionSocket.getInputStream()));
            rutFromLock = inFromClientText.readLine();
            inFromClientText.close();
            
            classRoom=serverdb.idLock2ClassRoomName(idLock);

            status=serverdb.getStatus(idLock);


            if(serverdb.ReadPermission(idLock).equals(rutFromLock) || serverdb.ReadSubPermission(idLock).equals(rutFromLock)){
                status=!status;

                if(status){
                    serverdb.SendToDB(classRoom,rutFromLock,"Acceso Permitido: Abriendo");
                    System.out.println("Sala:"+classRoom+" Rut:"+rutFromLock+" Acceso Permitido: Abriendo");
                }
                else{
                    serverdb.SendToDB(classRoom,rutFromLock,"Acceso Permitido: Cerrando");
                    System.out.println("Sala:"+classRoom+" Rut:"+rutFromLock+" Acceso Permitido: Cerrando");
                }

            }

            else if(status){
                serverdb.SendToDB(classRoom,rutFromLock,"Ingresado");
                System.out.println("Sala:"+classRoom+" Rut:"+rutFromLock+" Ingresado");
            }

            else{
                serverdb.SendToDB(classRoom,rutFromLock,"Acceso Denegado");
                System.out.println("Sala:"+classRoom+" Rut:"+rutFromLock+" Acceso Denegado");
            }


            

            
            serverdb.setStatus(idLock,status);

            connectionSocket = welcomeSocket.accept();

            outToClient = new DataOutputStream(connectionSocket.getOutputStream());
            

            outToClient.writeBoolean(status);

        }
    }





}
